package org.foo.bytebuddyexample;

import java.io.IOException;

public class AddSynchronizedInstanceLevelSaveMethod {

  public static void main(String[] args)
      throws InstantiationException, IllegalAccessException, NoSuchMethodException, IOException {
    // Simulate initialization of ORM:
    Saver saver = new Saver();
    // Save entity that doesn't track modified fields:
    saver.save(new Entity2(), new Flags());
    // Save entity that tracks modified fields:
    Class<?> setterTrackingEntityClass =
        EntityModificationUtils.setterTrackingEntityClass(Entity2.class);
    Entity2 entity0 = (Entity2) setterTrackingEntityClass.newInstance();
    System.out.println("entity0: " + System.identityHashCode(entity0));
    entity0.setFoo("foo");
    System.out.println(
        "contents of tracker after setting foo: "
            + EntityModificationUtils.getModifiedFields(entity0).iterator().next());
    saver.save(entity0, new Flags());
    Entity2 entity1 = (Entity2) setterTrackingEntityClass.newInstance();
    System.out.println("entity1: " + System.identityHashCode(entity1));
    System.out.println(
        "size of tracker: " + EntityModificationUtils.getModifiedFields(entity1).size());
    saver.save(entity1, new Flags());
  }
}
